package me.mrletsplay.nojs.component.impl;

import me.mrletsplay.nojs.action.Action;
import me.mrletsplay.nojs.component.ActionableComponent;
import me.mrletsplay.simplehttpserver.dom.html.HtmlElement;
import me.mrletsplay.simplehttpserver.dom.html.element.HtmlButton;

public class Button implements ActionableComponent {

	private String text;
	private Style style;
	private boolean enabled;
	private Action action;

	public Button() {
		this.text = "Button";
		this.style = Style.NORMAL;
		this.enabled = true;
	}

	public Button text(String text) {
		this.text = text != null ? text : "Button";
		return this;
	}

	public Button style(Style style) {
		this.style = style != null ? style : Style.NORMAL;
		return this;
	}

	public Button enabled(boolean enabled) {
		this.enabled = enabled;
		return this;
	}

	@Override
	public Button action(Action action) {
		this.action = action;
		return this;
	}

	@Override
	public HtmlElement toHtml() {
		HtmlButton button = HtmlElement.button();
		button.addClass("button");

		if(style != null) {
			button.setAttribute("data-style", style.name().toLowerCase());
		}

		if(!enabled) {
			button.setAttribute("disabled");
		}

		button.setText(text);

		if(action != null) {
			button.setAttribute("data-action");

			HtmlElement form = Form.createElement(action, null);
			form.appendChild(button);
			return form;
		}

		return button;
	}

	public static enum Style { // TODO

		NORMAL,
		LINK,
		;

	}

}
