package me.mrletsplay.nojs.component.impl;

import me.mrletsplay.nojs.component.Component;
import me.mrletsplay.simplehttpserver.dom.html.HtmlElement;

public class Link implements Component {

	private String text;
	private String href;

	public Link() {
		this.text = "Link";
		this.href = "#";
	}

	public Link text(String text) {
		this.text = text != null ? text : "Link";
		return this;
	}

	public Link href(String href) {
		this.href = href != null ? href : "#";
		return this;
	}

	@Override
	public HtmlElement toHtml() {
		HtmlElement link = HtmlElement.of("a");
		link.addClass("link");
		link.setText(text);
		link.setAttribute("href", href);
		return link;
	}

}
