package me.mrletsplay.nojs.component.impl;

import java.io.IOException;
import java.io.InputStream;
import java.nio.charset.StandardCharsets;

import me.mrletsplay.nojs.NoJS;
import me.mrletsplay.nojs.component.Component;
import me.mrletsplay.simplehttpserver.dom.html.HtmlElement;
import me.mrletsplay.simplehttpserver.dom.html.element.HtmlRaw;

public class Message implements Component {

	private String text;

	public Message() {
		this.text = "Message";
	}

	public Message text(String text) {
		this.text = text != null ? text : "Message";
		return this;
	}

	@Override
	public HtmlElement toHtml() {
		HtmlElement message = HtmlElement.of("div");
		message.addClass("message");

		HtmlElement textSpan = HtmlElement.of("span");
		textSpan.setText(text);
		message.appendChild(textSpan);

		HtmlElement checkLabel = HtmlElement.of("label");
		message.appendChild(checkLabel);

		HtmlElement check = HtmlElement.of("input");
		check.setAttribute("type", "checkbox");
		check.setAttribute("autocomplete", "off"); // Clear on reload
		checkLabel.appendChild(check);

		try(InputStream in = NoJS.class.getResourceAsStream("/icon/x.svg")) {
			checkLabel.appendChild(new HtmlRaw(new String(in.readAllBytes(), StandardCharsets.UTF_8)));
		}catch(IOException ex) {}

		return message;
	}

}
