package me.mrletsplay.nojs.page;

import java.util.ArrayList;
import java.util.List;

import me.mrletsplay.nojs.action.ActionEvent;
import me.mrletsplay.nojs.action.ActionHandlers;
import me.mrletsplay.nojs.component.Component;
import me.mrletsplay.nojs.page.layout.Layout;

public class StaticPage implements Page {

	private List<Component> components;
	private Layout layout;
	private List<ActionHandlers> actionHandlers;

	public StaticPage() {
		this.components = new ArrayList<>();
		this.actionHandlers = new ArrayList<>();
	}

	public StaticPage add(Component component) {
		components.add(component);
		return this;
	}

	public StaticPage layout(Layout layout) {
		this.layout = layout;
		return this;
	}

	public StaticPage addActionHandler(ActionHandlers handler) {
		actionHandlers.add(handler);
		return this;
	}

	@Override
	public List<Component> getComponents() {
		return components;
	}

	@Override
	public Layout getLayout() {
		return layout;
	}

	@Override
	public void onAction(ActionEvent event) {
		Page.super.onAction(event);

		for(ActionHandlers handler : actionHandlers) {
			handler.onAction(event);
		}
	}

}
